%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                 PSG Type    PSG Object                        Location in Problem Statement             Class
%matrix_cash_matching_objective_data    data        matrix_cash_matching_objective    linear(matrix_cash_matching_objective)    double
%matrix_cash_matching_objective_vars    vars        matrix_cash_matching_objective    linear(matrix_cash_matching_objective)    cell
%matrix_cash_matching_loss_benchmark    bench       matrix_cash_matching_loss         max_risk(matrix_cash_matching_loss)       double
%matrix_cash_matching_loss_data         data        matrix_cash_matching_loss         max_risk(matrix_cash_matching_loss)       double
%matrix_cash_matching_loss_vars         vars        matrix_cash_matching_loss         max_risk(matrix_cash_matching_loss)       cell
%parameter_bound_data                   data        parameter_bound                   Constraint: <= parameter_bound            double
%parameter_bound_1_data                 data        parameter_bound_1                 Box: >= parameter_bound_1                 double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_cash_matching_objective_data,matrix_cash_matching_objective_vars,matrix_cash_matching_loss_benchmark,matrix_cash_matching_loss_data,matrix_cash_matching_loss_vars,parameter_bound_data,parameter_bound_1_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_cash_matching_objective',matrix_cash_matching_objective_data,matrix_cash_matching_objective_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_cash_matching_loss',matrix_cash_matching_loss_data,matrix_cash_matching_loss_vars,matrix_cash_matching_loss_benchmark,[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  linear(matrix_cash_matching_objective)',...
'Constraint: <= parameter_bound',...
'  max_risk(matrix_cash_matching_loss)',...
'Box: >= parameter_bound_1',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

